#ifndef __time_h__
#define __time_h__

#ifndef __Is_Process__
#include "..\my_uboot\Var.h"
#endif

#ifdef MyPanda
#define k_My_CPU_Frequency	1000000000		
#else
#ifdef MyT12
#define k_My_CPU_Frequency	1000000000		
#else
#define k_My_CPU_Frequency	666666667		
#endif
#endif

#define k_My_Ticks_Per_us	(k_My_CPU_Frequency/1000000)


//**++

typedef int Timer_Int;

static inline Timer_Int ReadTimer(void) __attribute__((always_inline));

static inline Timer_Int ReadTimer(void)
{
  volatile Timer_Int time1;
  asm volatile(
		"mrc	p15,0,r6,c9,c13,0\n\t"
		"str	r6, %[val]\n\t"
		: [val] "=X" (time1)
		:
		:"r6"
		);
  return time1;
}


static inline Timer_Int ReadTimerf(void) __attribute__((always_inline));
static inline Timer_Int ReadTimerf(void)
{
  Timer_Int time1;
  asm volatile(
	  "mrc	p15,0,%[val],c9,c13,0\n\t"
		: [val] "=r" (time1)
		:
		:
		);
  return time1;
}

#define Read_Timer  ReadTimer
#define Read_Timer_F  ReadTimerf  

//**--


#ifndef __Is_Process__


int timer_init(void);
void udelay(unsigned long usec);

unsigned long long Read_Global_Timer(void);
unsigned long Read_Timer_2(void);

void Init_Private_Timer(unsigned int delay);

int Read_Private_Timer(void);

void Init_Private_Timer_Single_Shoot(unsigned int delay,void* handler);
void Private_Timer_Single_Shoot(unsigned int delay);
float Auslastung(Timer_Int volatile *lkl_last_time,__int64 volatile *lkl_last_idle,Timer_Int lkl_idle_time);

void Init_Timing(void);

void Timing_analyser_In(int value);
void Timing_analyser_Out(int value);

// ************** Neu MG 14.02.13 ************
void Init_and_Start_SWDT(void);
void Init_and_Start_privat_Watchdog(void);
// ************** Neu MG 14.02.13 Ende ************

#endif

#endif //__time_h__