#ifndef __Var_h__
#define __Var_h__


#ifndef __ASSEMBLY__
//**++                        // @@@@@@@@@@
typedef long long __int64;
typedef long long Int64;
//**--                       // @@@@@@@@@@@@

#ifndef __Bool_Defined__
#define __Bool_Defined__
typedef int bool;
typedef int Bool;
#endif

#define k_Cache_Line  64
//**++
#define k_Cache_Align
//**--
#ifndef __Is_Process__
#include "..\my_uboot\MemoryMap.h"
#else
#include "MemoryMap.h"
#endif //__Is_Process__

#else //__ASSEMBLY__
#include "MemoryMap.h"
#endif	//__ASSEMBLY__

#ifndef __ASSEMBLY__



#ifndef __Is_Process__
#include "..\my_uboot\Hardware_Addr.h"
#endif //__Is_Process__
#include "Process_Struct.h"

#ifndef __Is_Process__
#ifndef _is_Library
#include "..\SystemLib\memorymanager.h"
#endif
/*#else
#include "memorymanager.h"*/
#endif

//**++
#define k_Mem_Block_Start	k_MemoryMap_Vars_Start
#define	k_Process_Count		16
#define k_Par_Count			112
#define k_Data_Count		256
//**--

//**++
struct	Type_Process_Info
{
	Process_Struct *Process;
	long Pr_running;
	int	Pr_delay;
	long Pr_Event;
	long Pr_Schleife;
	long Pr_Version;
	long Pr_Fehler;
	//long dummy[9];
	long pr_tstart ;		// von Peter fr Processe vorgesehen.
	long pr_duration ;
	long pr_durmin ;
	long pr_durmax ;
	long pr_periode ;
	long pr_tstartold ;
	long pr_tendold ;
	//long dummy[2] ;             // 2013-08-12 P.H. 1 dummy f. pr_tlag vorsehen  , evtl pr_tlagmax auch vorsehen
	long dummy;
};
typedef struct Type_Process_Info Process_Info;
//**--

struct	Type_Timing_Info
{
	bool aktiv;
	long *ptr;	
	long size;
	long dummy;
};
typedef struct Type_Timing_Info Timing_Info;

//**++
//							   0x500	
#define ProcessArray		((Process_Info volatile*)(k_Mem_Block_Start))
// +16 * 4 * 16					=  0x900
#define Par		((long volatile*)((unsigned long)ProcessArray + sizeof(Process_Info) * k_Process_Count))
// + 112*4					=  0xb00
#define FPar	((double volatile*)((unsigned long)Par + sizeof(long) * k_Par_Count))
// + 112*8					=  0xe80
#define Datas	((void volatile**)((unsigned long)FPar + sizeof(double) * k_Par_Count))
// + 256 * 4				=  0x1280
#define Fifos_Struct_Ptr	((void volatile**)(k_MemoryMap_Vars2_Start))		//von 0x00102200 bis 0x00102600

#define timing_errors		((long volatile*)((unsigned long)Fifos_Struct_Ptr + 256*4))

#define Greatest_Stack_Size			((long volatile*)((unsigned long)timing_errors + k_Process_Count*4))
//**--

#ifndef __Is_Process__

#define idle_time_High				(*(Timer_Int *)(k_MemoryMap_Vars_Start + 0x1340))
#endif //__Is_Process__

//**++
#define	Low_Prio_Command			(*(long volatile*)(k_MemoryMap_Vars_Start + 0x1380))
#define	ist_System_Pro				(*(long volatile*)(k_MemoryMap_Vars_Start + 0x1390))
//**--
//#define idle_time_Low	(*(__int64 volatile*)(0x1380))

#ifndef __Is_Process__
// Achtung Reihenfolge und ABstand muessen gleich bleiben werden in HighPri_Processor_ASM.S benutzt !!!
#define ptr_Aktiver_High_Pri_Proc	(*(Process_Info **)(k_MemoryMap_Vars_Start + 0x13C0))
#define High_Pri_Proc_Cnt			(*(long volatile*)(k_MemoryMap_Vars_Start + 0x13C4))
#define main_loop					(*(long volatile*)(k_MemoryMap_Vars_Start + 0x013C8))
#define HighPriAktiv				(*(volatile long *)(k_MemoryMap_Vars_Start + 0x013CC))
#define ExternEventPtr				(*(volatile long *)(k_MemoryMap_Vars_Start + 0x013D0))
#define ExternEventProcess			(*(Process_Info **)(k_MemoryMap_Vars_Start + 0x013D4))
#define Fiq0_enabled				(*(volatile long *)(k_MemoryMap_Vars_Start + 0x013D8))	// 0 - Fiq ist gesperrt
#define Fiq1_enabled				(*(volatile long *)(k_MemoryMap_Vars_Start + 0x013DC))	// 0 - Fiq ist gesperrt

#define Last_Sync_Time				(*(long volatile*)(k_MemoryMap_Vars_Start + 0x013E0))
// ENDE Achtung Reihenfolge und ABstand muessen gleich bleiben werden in HighPri_Processor_ASM.S benutzt !!!



#define Critical_Section_aktiv		(*(volatile long *)(k_MemoryMap_Vars_Start + 0x01400))
#define Critical_Section_ack		(*(volatile long *)(k_MemoryMap_Vars_Start + 0x01404))
#define Critical_Section_kom		(*(volatile long *)(k_MemoryMap_Vars_Start + 0x01408))

#endif //__Is_Process__

#define Timing_Info_Struct			(*(volatile Timing_Info *)(k_MemoryMap_Vars_Start + 0x01420))

// Fr T121
#define UBoot_Version			(*(volatile long *)(k_MemoryMap_Vars_Start + 0x01500))

#else //__ASSEMBLY__

#define ProcessArray		(k_MemoryMap_Vars_Start)
#define High_Pri_Proc_Cnt	(k_MemoryMap_Vars_Start + 0x13C4)
#define HighPriAktiv		(k_MemoryMap_Vars_Start + 0x013CC)
#define ExternEventPtr		(k_MemoryMap_Vars_Start + 0x013D0)
#define ExternEventProcess	(k_MemoryMap_Vars_Start + 0x013D4)

#define Fiq_diseabled		(k_MemoryMap_Vars_Start + 0x013D8)	// 0 - Fiq ist gesperrt

#endif //__ASSEMBLY__

#ifndef __ASSEMBLY__

// 0x82200000 - 0x82300000 Bereich TLB Write-Through, no Write-Allocate 
//#define k_mem_WT_nWA	0x82200000
//#define HighPriAktiv	 (*(volatile long *)(k_MemoryMap_Vars_Start + 0x013C8))



// Ptr im Berich von 0x82080000 - 0x82090000
#ifndef __Is_Process__
#include "..\my_uboot\My_Systwmp_Pointers_Arm.h"
#else
#include "My_Systwmp_Pointers_Arm.h"
#endif


// Low Pri Vars
#define Scale_TicksToTime			(*(double volatile*)(k_MemoryMap_Vars_Start + 0x1600))
#define Scale_TimeToTicks	(*(double volatile*)(k_MemoryMap_Vars_Start + 0x1608))

#define Dbg_Copy_BinFile_To		(*(long volatile*)(k_MemoryMap_Vars_Start + 0x1614))

#ifndef __Is_Process__

#define Critical_Section_low_aktiv	(*(volatile long *) (k_MemoryMap_Vars_Start + 0x01610))

#define		ptr_spin_lock_enabled			(volatile long *)(k_MemoryMap_Spinlocks + 0x000)
#define		ptr_spin_lock_serial_puts		(volatile long *)(k_MemoryMap_Spinlocks + 0x004)
#define		ptr_spin_lock_mem_cacheable		(volatile long *)(k_MemoryMap_Spinlocks + 0x008)
#define		ptr_spin_lock_mem_uncacheable	(volatile long *)(k_MemoryMap_Spinlocks + 0x00C)
#define		ptr_spin_lock_Start_Komm_High	(volatile long *)(k_MemoryMap_Spinlocks + 0x010)
#define		ptr_spin_lock_Start_Komm_Low	(volatile long *)(k_MemoryMap_Spinlocks + 0x014)
#define		ptr_spin_lock_Start_High_Low	(volatile long *)(k_MemoryMap_Spinlocks + 0x018)
#define		ptr_spin_lock_Init_Interrput	(volatile long *)(k_MemoryMap_Spinlocks + 0x01C)

#ifdef MyPanda
#define k_memory_my_hard_start	(unsigned long)0x83fe0000
#endif

//#define k_memory_uncachable_start	(unsigned long)0x40000000
#define k_memory_uncachable_start	(unsigned long)k_MemoryMap_Malloc_Uncache
// Vorsicht auf 0x1500 MemoryInitLocation
#define k_memInit_Location				(unsigned long)k_MemoryMap_Malloc_Cache
#define k_memInit_Location_UC			(unsigned long)k_memory_uncachable_start

#endif //__Is_Process__

// andere Variablen

//**++																										// Namen geaendert ( Absprache mit J.K. ) 2014-02-17 P.H ++
																									   		// 2013-09-30 P.H. +++++
#define Sys_PtrToInfo						(*(volatile long *)(k_MemoryMap_Vars_Start + 0x01800))
#define Sys_PtrToCtrl						(*(volatile long *)(k_MemoryMap_Vars_Start + 0x01804))
#define Sys_PtrToCrt						(*(volatile long *)(k_MemoryMap_Vars_Start + 0x01808))
#define Sys_PtrToDoubles					(*(volatile long *)(k_MemoryMap_Vars_Start + 0x0180c))
#define Sys_PtrToGlobals                    (*(volatile long *)(k_MemoryMap_Vars_Start + 0x01810))         	// 2013-10-07 P.H.

#define Sys_PtrToTime_Info                  (*(volatile long *)(k_MemoryMap_Vars_Start + 0x01814))         	// 2013-10-22 P.H.
																										   	// braucht 9 longs equiv. 36 Bytes
#define Sys_PtrToUnix_Time                    (*(volatile long *)(k_MemoryMap_Vars_Start + 0x01838))       	// 2013-10-22 P.H.

#define Sys_PtrToMemCpy                      (*(Mymemcpy *)(k_MemoryMap_Vars_Start + 0x0183C))         		// 2013-10-23 P.H.     geht nicht Ursache ????

#define Sys_Dedug_Help1              	((long volatile *)((unsigned long)k_MemoryMap_Vars_Start + 0x01840))         // 2013-10-25 P.H. 16 Longs Debughilfe

#define Sys_MemSet_Speed					(*(long volatile*)(k_MemoryMap_Vars_Start + 0x1880 ))           // 2014-02-11 P.H. wg. memset() ...
#define Sys_Debug_Help2						(*(long volatile*)(k_MemoryMap_Vars_Start + 0x1884 ))           // 2014-02-12 P.H.


#define Sys_PtrToFirst_Spare                (*(volatile long *)(k_MemoryMap_Vars_Start + 0x01888))         	// 2013-10-23 P.H.   2014-02-12 P.H.
                                                                                                     		// Namen geaendert ( Absprache mit J.K. ) 2014-02-17 P.H --
//**--


//**********************************************************************
// Bereich gemicht
//**********************************************************************

#ifndef _is_Library

#ifndef __Is_Process__

extern int volatile my_key_code;
extern int volatile anzeige;

extern unsigned int CPU_Frequenz;
extern short	Bus_Ratio;

extern Memory_Info	* volatile ptr_memory_info_cacheable;
extern Memory_Info	* volatile ptr_memory_info_Uncacheable;

extern int Init_Interrupts_done;
extern Process_Struct * volatile starte_von_high_low;
extern Process_Struct * volatile starte_von_high_high;
extern Process_Struct * volatile starte_von_komm_high;
extern Process_Struct *volatile stope_von_komm_high;
extern Process_Struct * volatile starte_von_komm_low;
extern Process_Struct * volatile starte_von_low_high;
extern Process_Struct * volatile starte_von_low_low;
extern long __intel_cpu_indicator;
extern int volatile vars_are_init;

extern int volatile IRQ_stack_ptr;

#endif //__Is_Process__
//**********************************************************************
//**********************************************************************
// Bereich nur Low Pri
//**********************************************************************
//**++
// BitMuster
#define k_Low_Prio_Command_Active				0x00000001
#define k_Low_Prio_Command_Ready				0x00000002
#define k_Low_Prio_Command_Mask_Ready			0xfffffffd
#define k_Low_Prio_Command_End					0x00000004
#define k_Low_Prio_Command_Mask_End				0xfffffffb
#define k_Low_Prio_Command_Crit					0x00000008
#define k_Low_Prio_Command_Mask_Crit			0xfffffff7
#define k_Low_Prio_Command_LowInit_Ready		0x00000010
#define k_Low_Prio_Command_Mask_LowInit_Ready	0xffffffef
#define k_Low_Prio_Command_Restart				0x00000020
#define k_Low_Prio_Command_Mask_Restart			0xffffffdf
//**--
#ifndef __Is_Process__


extern Process_Struct *akiver_low_pri_proc;
extern Process_Struct * volatile liste_low_waiting;
extern Process_Struct * volatile liste_low_aktiv;

extern int volatile Timer_Low_first;

extern int volatile idle_time_Low;

extern int volatile last_time_high;
extern __int64 volatile last_idle_high;
extern int volatile last_time_low;
extern __int64 volatile last_idle_low;


extern int Komm_Set_Phase_channel;
extern double ticks_per_low_pri_time;

//**********************************************************************
//**********************************************************************
// Bereich nur High Pri
//**********************************************************************
//extern long High_Pri_Proc_Cnt;
extern Process_Struct *volatile*ptr_akiver_High_pri_proc;
extern Process_Struct *liste_High_waiting;
extern Process_Struct  *volatile akiver_High_pri_proc;

#endif //__Is_Process__

//extern unsigned int Proc_1_Stack_ptr;
//extern long save_ebp_Proc1,save_esp_Proc1;

//**********************************************************************


/*
__inline int Get_Processdelay(int Process_No)
{
      return ProcessArray[Process_No].Pr_delay;      
}

__inline void Set_Processdelay(int Process_No, int delay)
{
      ProcessArray[Process_No].Pr_delay = delay;
}
*/

#ifndef true
#define true	1
#endif

#ifndef TRUE
#define TRUE	1
#endif

#ifndef True
#define True	1
#endif

#ifndef false
#define false	0
#endif

#ifndef FALSE
#define FALSE	0
#endif

#ifndef False
#define False	0
#endif



//#include "LowPri_Processor.h"


//void Set_long_value(long volatile *addr,long value);

/*
__inline void Set_double_value(double volatile *addr,double value)
{
	//Wait_HighPri_Ready();
	*addr = value;	
};
*/

/*
long Get_Par(int index);
double Get_FPar(int index);

void Set_Par(int index,long value);
void Set_FPar(int index,double value);
*/

#ifndef __Is_Process__

void Init_Vars(void);

#endif //__Is_Process__

#else //_is_Library

#define true	1
#define false	0

#endif //_is_Library

#endif //__ASSEMBLY__

#endif	//__Var_h__