'<TiCoBasic Header, Headerversion 001.001>
' Foldings                       = 25,151,233
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'##############################################################################
'#                        SPI_TiCo.inc                                        #
'##############################################################################
'#                                                                            #
'#                                                                            #
'#  27.02.2018  mf   creation                                                 #                                                                            #
'#  10.12.2018  mf bugfix debug mode                                          #
'#                                                                            #
'# Attention:                                                                 #
'#   - Do not copy the first source line (containing                          #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !                             #
'#     Otherwise the Syntax color may be not correct.                         #
'#   - This includefile requires ADbasic 5 or higher!                         #
'#                                                                            #
'##############################################################################


#if adwin_system = ADwin_ProII
#else
#error("This include file can only be used with the ADwin ProII")  
#endif

'<REGION> define

'Address defines
#define CANFD_ADR_C1CON        00000h         ''<HIDE>
#define CANFD_ADR_C1NBTCFG     00004h         ''<HIDE>
#define CANFD_ADR_C1DBTCFG     00008h         ''<HIDE>
#define CANFD_ADR_C1TDC        0000Ch         ''<HIDE>
#define CANFD_ADR_C1TBC        00010h         ''<HIDE>
#define CANFD_ADR_C1TSCON      00014h         ''<HIDE>
#define CANFD_ADR_C1VEC        00018h         ''<HIDE>
#define CANFD_ADR_C1INT        0001Ch         ''<HIDE>
#define CANFD_ADR_C1RXIF       00020h         ''<HIDE>
#define CANFD_ADR_C1TXIF       00024h         ''<HIDE>
#define CANFD_ADR_C1RXOVIF     00028h         ''<HIDE>
#define CANFD_ADR_C1TXATIF     0002Ch         ''<HIDE>
#define CANFD_ADR_C1TXREQ      00030h         ''<HIDE>
#define CANFD_ADR_C1TREC       00034h         ''<HIDE>
#define CANFD_ADR_C1BDIAG0     00038h         ''<HIDE>
#define CANFD_ADR_C1BDIAG1     0003Ch         ''<HIDE>
#define CANFD_ADR_C1TEFCON     00040h         ''<HIDE>
#define CANFD_ADR_C1TEFSTA     00044h         ''<HIDE>
#define CANFD_ADR_C1TEFUA      00048h         ''<HIDE>
#define CANFD_Reserved         0004Ch         ''<HIDE>
#define CANFD_ADR_C1TXQCON     00050h         ''<HIDE>
#define CANFD_ADR_C1TXQSTA     00054h         ''<HIDE>
#define CANFD_ADR_C1TXQUA      00058h         ''<HIDE>
#define CANFD_ADR_C1FIFOCON1   0005Ch         ''<HIDE>
#define CANFD_ADR_C1FIFOSTA1   00060h         ''<HIDE>
#define CANFD_ADR_C1FIFOUA1    00064h         ''<HIDE>
#define CANFD_ADR_C1FIFOCON2   00068h         ''<HIDE>
#define CANFD_ADR_C1FIFOSTA2   0006Ch         ''<HIDE>
#define CANFD_ADR_C1FIFOUA2    00070h         ''<HIDE>
#define CANFD_FIFO_OFFSET      0000Ch         ''<HIDE> 

#define CANFD_ADR_C1FLTCON0    001D0h         ''<HIDE>
#define CANFD_ADR_C1FLTOBJ0    001F0h         ''<HIDE>
#define CANFD_ADR_C1MASK0      001F4h         ''<HIDE>
#define CANFD_ADR_C1FLTOBJ1    001F8h         ''<HIDE>
#define CANFD_ADR_C1MASK1      001FCh         ''<HIDE>
#define CANFD_ADR_C1FLTOBJ2    00200h         ''<HIDE>
#define CANFD_ADR_C1MASK2      00204h         ''<HIDE>
#define CANFD_FILTER_OFFSET    00008h         ''<HIDE>
#define CANFD_ADR_RAM_OFFSET   00400h         ''<HIDE>
#define CANFD_ADR_TXQ0         00400h         ''<HIDE>
#define CANFD_ADR_TXQ1         00404h         ''<HIDE>
#define CANFD_ADR_TXQ2         00408h         ''<HIDE>
#define CANFD_ADR_TXQ3         0040Ch         ''<HIDE>
#define CANFD_ADR_TXQ4         00410h         ''<HIDE>
#define CANFD_ADR_TXQ5         00414h         ''<HIDE>
#define CANFD_ADR_TXQ6         00418h         ''<HIDE>
#define CANFD_ADR_TXQ7         0041Ch         ''<HIDE>
#define CANFD_ADR_TXQ8         00420h         ''<HIDE>
#define CANFD_ADR_TXQ9         00424h         ''<HIDE>
#define CANFD_ADR_TXQ10        00428h         ''<HIDE>
#define CANFD_ADR_TXQ11        0042Ch         ''<HIDE>
#define CANFD_ADR_TXQ12        00430h         ''<HIDE>
#define CANFD_ADR_TXQ13        00434h         ''<HIDE>
#define CANFD_ADR_TXQ14        00438h         ''<HIDE>
#define CANFD_ADR_TXQ15        0043Ch         ''<HIDE>
#define CANFD_ADR_TXQ16        00440h         ''<HIDE>
#define CANFD_ADR_TXQ17        00444h         ''<HIDE>
#define CANFD_ADR_TXQ18        00448h         ''<HIDE>

#define CANFD_ADR_OSC          00E00h         ''<HIDE>
#define CANFD_ADR_IOCON        00E04h         ''<HIDE>
#define CANFD_ADR_CRC          00E08h         ''<HIDE>
#define CANFD_ADR_ECCCON       00E0Ch         ''<HIDE>
#define CANFD_ADR_ECCSTAT      00E10h         ''<HIDE>

'Index defines
#define CANFD_IDX_MODUL        00001h         ''<HIDE>
#define CANFD_IDX_CHANNEL      00002h         ''<HIDE>
#define CANFD_LAST_Write_Pointer 00003h       ''<HIDE>
#define CANFD_FREE_RAM         00004h         ''<HIDE>
#define CANFD_BDIAG0           00005h         ''<HIDE>
#define CANFD_BDIAG1           00006h         ''<HIDE>
#define CANFD_TREC             00007h         ''<HIDE>
#define CANFD_IDX_C1CON        00011h         ''<HIDE>
#define CANFD_IDX_C1NBTCFG     00012h         ''<HIDE>
#define CANFD_IDX_C1DBTCFG     00013h         ''<HIDE>
#define CANFD_IDX_C1TDC        00014h         ''<HIDE>
#define CANFD_IDX_C1TBC        00015h         ''<HIDE>
#define CANFD_IDX_C1TSCON      00016h         ''<HIDE>
#define CANFD_IDX_C1VEC        00017h         ''<HIDE>
#define CANFD_IDX_C1INT        00018h         ''<HIDE>
#define CANFD_IDX_C1RXIF       00019h         ''<HIDE>
#define CANFD_IDX_C1TXIF       0001Ah         ''<HIDE>
#define CANFD_IDX_C1RXOVIF     0001Bh         ''<HIDE>
#define CANFD_IDX_C1TXATIF     0001Ch         ''<HIDE>
#define CANFD_IDX_C1TXREQ      0001Dh         ''<HIDE>
#define CANFD_IDX_C1TREC       0001Eh         ''<HIDE>
#define CANFD_IDX_C1BDIAG0     0001Fh         ''<HIDE>
#define CANFD_IDX_C1BDIAG1     00020h         ''<HIDE>
#define CANFD_IDX_C1TEFCON     00021h         ''<HIDE>
#define CANFD_IDX_C1TEFSTA     00022h         ''<HIDE>
#define CANFD_IDX_C1TEFUA      00023h         ''<HIDE>
#define Reserved_IDX           00024h         ''<HIDE>
#define CANFD_IDX_C1TXQCON     00025h         ''<HIDE>
#define CANFD_IDX_C1TXQSTA     00026h         ''<HIDE>
#define CANFD_IDX_C1TXQUA      00027h         ''<HIDE>
#define CANFD_IDX_C1FIFOCON1   00028h         ''<HIDE>
#define CANFD_IDX_C1FIFOSTA1   00029h         ''<HIDE>
#define CANFD_IDX_C1FIFOUA1    0002Ah         ''<HIDE>
#define CANFD_IDX_C1FIFO_OFFSET  003h         ''<HIDE>

#define CANFD_IDX_C1FLTCON0    00100h         ''<HIDE>
#define CANFD_IDX_C1FLTOBJ0    00120h         ''<HIDE>
#define CANFD_IDX_C1MASK0      00140h         ''<HIDE>

#define CANFD_IDX_OSC          001F0h         ''<HIDE>
#define CANFD_IDX_IOCON        001F1h         ''<HIDE>
#define CANFD_IDX_CRC          001F2h         ''<HIDE>
#define CANFD_IDX_ECCCON       001F3h         ''<HIDE>
#define CANFD_IDX_ECCSTAT      001F4h         ''<HIDE>

'Mode defines
#define CANFD_MODE_CANFD  0
#define CANFD_MODE_CONFIG 4                   ''<HIDE>
#define CANFD_MODE_CAN    6
'Bit defines
#define CANFD_BIT_RXOVIF        08H
#define CANFD_INIT_OK 1
#define CANFD_INIT_NIO 0

'<ENDREGION>

'<REGION> System
Import can_FD_TICO_LIB.TL1




'***************************************************************
''' Converts a process frequency [Hz] into processor ticks (processdelay or cycle time).
''' frequency:  frequency[Hz]
'''*************************************************************
Function Calc_Processdelay(frequency) as long
  
#if prozessor = tico1
  calc_processdelay = 50000000 / (frequency)
#else
  calc_processdelay = 100000000 / (frequency)
#endif
  
endfunction
'---------------------------------------------------------------
' If a low-priority process accesses a Pro-module it must not be
' interrupted by any other process !!!
'---------------------------------------------------------------

Sub Sub_Begin_Critical_Section() ''<HIDE>
#If PRIORITAET = LOW
  Begin_Critical_Section
#EndIf
EndSub

Sub Sub_End_Critical_Section() ''<HIDE>
#If PRIORITAET = LOW
  End_Critical_Section
#EndIf
EndSub

'******************************************************************************
'''Switches the LED on or off.
'''value: 
'''+  0 off
'''+  1 on
'''****************************************************************************
SUB Set_LED(value)
  out (80804000H, value)
ENDSUB

'******************************************************************************
'''Checks the LED.
'''+Return:
'''+   0 off
'''+   1 on
'''****************************************************************************
FUNCTION Check_LED() AS Long
  Check_LED = in(80804000h)
ENDFUNCTION

'*******************************************************************************
'''Creates an event for the master cpu.
'''*****************************************************************************
SUB Trigger_Event()
  out (108041E0h, 1)
ENDSUB

    
Sub System_Array_Debug_Check(array[], startindex, length)  '<HIDE>
#IF DEBUG_MODE = ON THEN
  if ((startindex) + (length) - 1 > Get_Array_Length(array[1])) then
    PROZESS_FEHLER = 0C1000000H or Get_Array_No(array[1])
    end
  endif
  ''  
  if ((startindex) < 1) then 
    PROZESS_FEHLER = 0C2000000H or Get_Array_No(array[1])
    end
  endif
#endif
ENDSUB



'<ENDREGION>

'<REGION> CAN FD

'******************************************************************************
'''Sets CAN LEDs on/off for the CAN channel.
'''channel: number of the CAN interface on the CAN module
'''+(also necessary If the module provides only one channel)
'''led_col: 
'''+         0 = LED off 
'''+         1 = LED red  
'''****************************************************************************
Sub CANFD_Set_LED(channel, led_col)
  out (10000150H + ((channel) * 1000h), led_col)
EndSub

'***************************************************************************
''' Sets a 32 Bit register of the CAN-controller via SPI interface.
'''+SPI stream consists of 
'''+Bit 0-3:     Commandcode
'''+Bit 4-15:    Adress
'''+Bit 16-47:   Value
''' module : number of CAN module
''' channel : number of the CAN interface on the CAN module
''' adress: adress of the register which should be set
''' value: value which should be written to the register.
'''****************************************************************************
SUB CANFD_Set_Reg(channel, adress, value) ''<HIDE>
  CANFD_Set_Reg_LIB(channel, adress, value) 
ENDSUB

'***************************************************************************
''' Request of a 32 Bit register of the CAN-controller via SPI interface.
'''+SPI stream consists of 
'''+Bit 0-3:     Commandcode
'''+Bit 4-15:    Adress
'''+To get the value when the SPI transfer is finished the command 
'''+CANFD_Read_Reg should be used.
''' channel : number of the CAN interface on the CAN module
''' adress: adress of the register which should be requested
'''****************************************************************************
SUB CANFD_Req_Reg(channel, adress) ''<HIDE>
  CANFD_Req_Reg_LIB(channel, adress)
ENDSUB

'***************************************************************************
''' Read a 32 Bit register of the CAN-controller via SPI interface.
'''+SPI stream consists of 
'''+Bit 16-47:   Value
'''+The value has to be requested before by the command CANFD_Req_Reg.
''' channel : number of the CAN interface on the CAN module
'''****************************************************************************
FUNCTION CANFD_Read_Reg(channel) AS LONG ''<HIDE>
  CANFD_Read_Reg = CANFD_Read_Reg_LIB(channel) 
ENDFUNCTION

'***************************************************************************
''' Read a 32 Bit register of the CAN-controller via SPI interface.
'''+SPI stream consists of 
'''+Bit 0-3:     Commandcode
'''+Bit 4-15:    Adress
'''*Bit 16-47:   Value
''' channel : number of the CAN interface on the CAN module
'''****************************************************************************
FUNCTION CANFD_Get_Reg(channel, adress) AS LONG 
  CANFD_Get_Reg = CANFD_Get_Reg_LIB(channel, adress) 
ENDFUNCTION

'***************************************************************************
''' Reset of the CAN-controller via SPI interface.
'''+SPI stream consists of 
'''+Bit 0-3:     Commandcode (Reset)
'''+Bit 4-15:    Adress = 0
'''+Bit 16-47:   Value = 0
''' channel : number of the CAN interface on the CAN module
'''****************************************************************************
SUB CANFD_Reset(channel)   ''<HIDE>
  CANFD_Reset_LIB(channel)
ENDSUB

'***************************************************************************
''' Calculation of the number of bytes required in the RAM area to create the
'''+corresponding FIFO or queue.
''' PLS : Payload size ; 0 = 8, 1 = 12; 2 = 16; 3 = 20 ; 4 = 24; 5 = 32; 6 = 48
'''                      7 = 64
''' FIFO_SIZE : number of fifo elements 
''' TIMESTAMP : 0 = Timestamp disabled; 1 = Timestamp enabled
'''****************************************************************************
FUNCTION CANFD_CALC_RAM_SIZE(PLS, FIFO_SIZE, TIMESTAMP) AS LONG '<HIDE>
  DIM My_fifo_size AS LONG
  My_fifo_size = fifo_size - 1
  CANFD_CALC_RAM_SIZE = CANFD_CALC_RAM_SIZE_LIB(PLS, My_fifo_size, TIMESTAMP)
ENDFUNCTION

'***************************************************************************
''' Calculation of the number of data bytes based on the DLC.
''' DLC : Data lenght code
'''****************************************************************************
FUNCTION CANFD_CALC_No_Data_BYTES(DLC) AS LONG                       '<HIDE<
  IF (DLC <= 8) THEN CANFD_CALC_No_Data_BYTES = DLC
  IF (DLC = 9) THEN CANFD_CALC_No_Data_BYTES = 12
  IF (DLC = 10) THEN CANFD_CALC_No_Data_BYTES = 16
  IF (DLC = 11) THEN CANFD_CALC_No_Data_BYTES = 20
  IF (DLC = 12) THEN CANFD_CALC_No_Data_BYTES = 24
  IF (DLC = 13) THEN CANFD_CALC_No_Data_BYTES = 32
  IF (DLC = 14) THEN CANFD_CALC_No_Data_BYTES = 48
  IF (DLC = 15) THEN CANFD_CALC_No_Data_BYTES = 64
ENDFUNCTION

'***************************************************************************
''' Calculation of the number of registers of a message object.
''' DLC : Data lenght code
''' TIMESTAMP : 0 = Timestamp disabled; 1 = Timestamp enabled
'''****************************************************************************
FUNCTION CANFD_CALC_NO_DATA_REG(DLC, TIMESTAMP) AS LONG    '<HIDE>
  CANFD_CALC_NO_DATA_REG = CANFD_CALC_NO_DATA_REG_LIB(DLC, TIMESTAMP) 
ENDFUNCTION 

'***************************************************************************
''' Reads a receive message object form the CAN controller
''' Fifo_no : number of the fifo from which the object should be read
''' CAN_MSG : array to which the object should be written; the lenght must be at least 20 elements
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
FUNCTION CANFD_Read_RMO(Fifo_no, CANFD_datatable[], CAN_MSG[]) AS LONG
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_Read_RMO = CANFD_Read_RMO_LIB(Fifo_no, CANFD_datatable, CAN_MSG) 
ENDFUNCTION
'***************************************************************************
''' Sets the mode variable in the CANFD_datatable
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512 
'''****************************************************************************
SUB CANFD_Set_Mode(mode, CANFD_datatable[]) 
  CANFD_Set_Mode_LIB(mode, CANFD_datatable) 
ENDSUB

'***************************************************************************
''' Initiallize the CAN controller '1 =OK , 0=errror
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
Function CANFD_Init_Controller(CANFD_datatable[]) as long
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_Init_Controller = CANFD_Init_Controller_LIB(CANFD_datatable)
ENDFunction

'***************************************************************************
'''Checks the state of a fifo
'''+ return value : Transmit FIFO Bit 0 : Fifo is not full (value = 1)
'''+                              Bit 1 : Fifo is >= half full 
'''+                              Bit 2 : Fifo is empty 
'''+                              Bit 5 : Bus error occured while the message was being sent
'''+                              Bit 6 : Message lost arbitration while being sent
'''+                              Bit 7 : Message lost was aborted
'''+return value : Receive FIFO   Bit 0 : Fifo is not empty (value = 1)
'''+                              Bit 1 : Fifo is < half full 
'''+                              Bit 2 : Fifo is empty 
'''+                              Bit 3 : Fifo overflowe
'''Fifo_no : number of the fifo from which the object should be read
'''****************************************************************************
FUNCTION CANFD_GET_FIFO_STATE(channel, Fifo_no) AS LONG
  CANFD_GET_FIFO_STATE = CANFD_GET_FIFO_STATE_LIB(channel, Fifo_no) 
ENDFUNCTION

'***************************************************************************
''' Calculates the values for CAN_MSG[1] and CAN_MSG[2] and writes it to the array
''' ID : Indtifier
''' SEQ : Sequence to keep track of transmitted messages in Transmit event FIFO
''' FDF : FD Frame
''' BRS : Bit rate switch
''' RTR : Remote transmition request; not used in FD mode
''' IDE : Identifier extention flag
''' DLC : Data lenght code
''' CAN_MSG : array to which the values should be written; the lenght must be at least 20 elements
'''+         CAN_MSG[1] = Header 
'''+         CAN_MSG[2] = Header
'''+         CAN_MSG[3..n] = Payload; n depends on DLC
'''****************************************************************************
SUB CANFD_Write_TMO_Header(ID, SEQ, FDF, BRS, RTR, IDE, DLC, CAN_MSG[])  ''<HIDE>
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  CANFD_Write_TMO_Header_LIB(ID, SEQ, FDF, BRS, RTR, IDE, DLC, CAN_MSG)
ENDSUB
'***************************************************************************
''' Writes to a transmit message object to the RAM area of the CAN controller
'''+ return value : -1 : Fifo full ; data is not set
'''+                0  : OK
''' Fifo_no : number of the fifo from which the object should be read
''' CAN_MSG : array to which the object should be written; the lenght must be at least 20 elements
'''+         CAN_MSG[1] = Header ; must be set before this function; e.g. by sub CANFD_Write_TMO_Header_LIB
'''+         CAN_MSG[2] = Header ; must be set before this function; e.g. by sub CANFD_Write_TMO_Header_LIB
'''+         CAN_MSG[3..n] = Payload; n depends on DLC
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
FUNCTION CANFD_Write_TMO_RAM(Fifo_no, DLC, CAN_MSG[], CANFD_datatable[]) AS LONG  ''<HIDE>
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_Write_TMO_RAM = CANFD_Write_TMO_RAM_LIB(Fifo_no, DLC, CAN_MSG, CANFD_datatable) 
ENDFUNCTION
'***************************************************************************
''' Writes to a transmit message object in the CAN controller
'''+ return value : -1 : Fifo full ; data is not set
'''+                0  : OK
''' Fifo_no : number of the fifo from which the object should be read
''' ID : Indtifier
''' SEQ : Sequence to keep track of transmitted messages in Transmit event FIFO
''' FDF : FD Frame
''' BRS : Bit rate switch
''' RTR : Remote transmition request; not used in FD mode
''' IDE : Identifier extention flag
''' DLC : Data lenght code
''' CAN_MSG : array to which the object should be written ; the lenght must be at least 20 elements
'''+         CAN_MSG[1] = Header ; can be empty; this part will be prepared by this function
'''+         CAN_MSG[2] = Header ; can be empty; this part will be prepared by this function
'''+         CAN_MSG[3..n] = Payload; n depends on DLC
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512 
'''****************************************************************************
FUNCTION CANFD_Write_TMO(Fifo_no, ID, SEQ, FDF, BRS, RTR, IDE, DLC, CAN_MSG[], CANFD_datatable[]) AS LONG
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_Write_TMO = CANFD_Write_TMO_LIB(Fifo_no, ID, SEQ, FDF, BRS, RTR, IDE, DLC, CAN_MSG, CANFD_datatable) 
ENDFUNCTION
'+***************************************************************************
'''Extracts the header information from CAN_MSG[1] and CAN_MSG[2] in
'''its parts.
'''CAN_MSG : array from which the parts should be extracted ; the lenght must be at least 20 elements
'''canfd_datatable: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512 
'''ID : Indtifier
'''SEQ : Sequence to keep track of transmitted messages in Transmit event FIFO
'''ESI : Error Status Indicator
'''FDF : FD Frame
'''BRS : Bit rate switch
'''RTR : Remote transmition request; not used in FD mode
'''IDE : Identifier extention flag
'''DLC : Data lenght code
''' ***************************************************************************
SUB CANFD_Get_Header_Parts(CAN_MSG[], CANFD_datatable[], ID, ESI, FDF, BRS, RTR, IDE, DLC)
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  ID = CANFD_Get_ID(can_msg, canfd_datatable, IDE)
  ESI = CANFD_Get_ESI(CAN_MSG)
  FDF = CANFD_Get_FDF(CAN_MSG)
  BRS = CANFD_Get_BRS(CAN_MSG)
  RTR = CANFD_Get_RTR(CAN_MSG)
  IDE = CANFD_Get_IDE(CAN_MSG)
  DLC = CANFD_Get_DLC(CAN_MSG)
ENDSUB
'***************************************************************************
''' Extracts the ID from CAN_MSG[1] 
'''+ return value : ID = Indtifier
''' CAN_MSG : array from which the part should be extracted ; the lenght must be at least 20 elements
''' ***************************************************************************
FUNCTION CANFD_Get_ID(CAN_MSG[], CANFD_datatable[], IDE) AS LONG
  DIM SID11_Enabled AS LONG 
  System_Array_Debug_Check(can_msg, 1, 20)
  System_Array_Debug_Check(canfd_datatable, 1, 512)
  SID11_Enabled = SHIFT_RIGHT(canfd_datatable[CANFD_IDX_C1TDC], 24) AND 01H
  IF (IDE = 0) THEN 
    IF (SID11_Enabled = 0) THEN   '11BIt ID
      CANFD_Get_ID = CAN_MSG[1] AND 07FFH
    ELSE                          '12BIt ID
      CANFD_Get_ID = CAN_MSG[1] AND 0FFFH
    ENDIF
  ELSE                            '29BIt ID 
    CANFD_Get_ID = SHIFT_LEFT((CAN_MSG[1] AND 3FFH), 18) OR SHIFT_RIGHT((CAN_MSG[1] AND 1FFFF800H), 11)
  ENDIF
ENDFUNCTION
'***************************************************************************
''' Extracts the ESI from CAN_MSG[2] 
'''+ return value : ESI = Error Status Indicator
''' CAN_MSG : array from which the part should be extracted ; the lenght must be at least 20 elements
''' ***************************************************************************
FUNCTION CANFD_Get_ESI(CAN_MSG[]) AS LONG
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  CANFD_Get_ESI = SHIFT_RIGHT(CAN_MSG[2], 8) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts the FDF from CAN_MSG[2] 
'''+ return value : FDF = FD Frame
''' CAN_MSG : array from which the part should be extracted ; the lenght must be at least 20 elements
''' ***************************************************************************
FUNCTION CANFD_Get_FDF(CAN_MSG[]) AS LONG
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  CANFD_Get_FDF = SHIFT_RIGHT(CAN_MSG[2], 7) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts the BRS from CAN_MSG[2] 
'''+ return value : BRS = Bit rate switch
''' CAN_MSG : array from which the part should be extracted ; the lenght must be at least 20 elements
''' ***************************************************************************
FUNCTION CANFD_Get_BRS(CAN_MSG[]) AS LONG
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  CANFD_Get_BRS = SHIFT_RIGHT(CAN_MSG[2], 6) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts the RTR from CAN_MSG[2] 
'''+ return value : RTR = Remote transmition request; not used in FD mode
''' CAN_MSG : array from which the part should be extracted ; the lenght must be at least 20 elements
''' ***************************************************************************
FUNCTION CANFD_Get_RTR(CAN_MSG[]) AS LONG
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  CANFD_Get_RTR = SHIFT_RIGHT(CAN_MSG[2], 5) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts the IDE from CAN_MSG[2] 
'''+ return value : IDE = Identifier extention flag
''' CAN_MSG : array from which the part should be extracted ; the lenght must be at least 20 elements
''' ***************************************************************************
FUNCTION CANFD_Get_IDE(CAN_MSG[]) AS LONG
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  CANFD_Get_IDE = SHIFT_RIGHT(CAN_MSG[2], 4) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts the DLC from CAN_MSG[2] 
'''+ return value : DLC = Data lenght code
''' CAN_MSG : array from which the part should be extracted ; the lenght must be at least 20 elements
''' ***************************************************************************
FUNCTION CANFD_Get_DLC(CAN_MSG[]) AS LONG
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  CANFD_Get_DLC = CAN_MSG[2] AND 0FH
ENDFUNCTION

'***************************************************************************
''' Initialisation of the datatable. This should be the first command 
'''+corresponding to a CAN-Interface. Followed by the configuration commands
'''+enable_XXX_FIFO; enable_XXX_queue; SET_XXX_Baudrate, ...
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
SUB CANFD_Init_CANFD_datatable(channel, CANFD_datatable[])
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_Init_CANFD_datatable_LIB(channel, CANFD_datatable)
ENDSUB

'***************************************************************************
''' Modifies the datatable by adding a receive FIFO and a filter which is 
''' dedicated to this fifo. This command makes no
''' access to the CAN-Controller. The CAN-Controller is accessed by 
''' CANFD_Init_Controller.
'''+ return value : -1 : RAM full ; Fifo is not set
'''+                0  : OK
''' Fifo_no : number of the fifo from which the object should be read
''' PLZ : pay load Size 0 =  8 data byte
'''+                    1 = 12 data byte
'''+                    2 = 16 data byte
'''+                    3 = 20 data byte
'''+                    4 = 24 data byte
'''+                    5 = 32 data byte
'''+                    6 = 48 data byte
'''+                    7 = 64 data byte
''' Fifo_size : depth of the fifo
''' Timestamp : 1 = timestamp activ; 0 = no timestamp
''' ID : Idetifier for the filter
''' Mask : Mask for the filter
''' Extended : 0 = 11 Bit identifier; 1 = 29 Bit identifier
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
FUNCTION CANFD_Enable_Receive_Fifo(Fifo_no, PLS, Fifo_size, Timestamp, ID, Mask, Extendet, CANFD_datatable[]) AS LONG
  DIM My_fifo_size AS LONG
  My_fifo_size = fifo_size - 1
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_Enable_Receive_Fifo = CANFD_Enable_Receive_Fifo_LIB(Fifo_no, PLS, My_fifo_size, Timestamp, ID, Mask, Extendet, CANFD_datatable) 
ENDFUNCTION
'***************************************************************************
''' Modifies the datatable by activating and configuring the transmit event FIFO.
'''+This command makes no access to the CAN-Controller. The CAN-Controller 
'''+is accessed by CANFD_Init_Controller.
'''+ return value : -1 : RAM full ; Fifo is not set
'''+                0  : OK
''' Fifo_no : number of the fifo from which the object should be read
''' Fifo_size : depth of the fifo
''' Timestamp : 1 = timestamp activ; 0 = no timestamp
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
FUNCTION CANFD_Enable_Transmit_Event_Fifo(Fifo_size, Timestamp, CANFD_datatable[]) AS LONG
  DIM My_fifo_size AS LONG
  My_fifo_size = fifo_size - 1
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_Enable_Transmit_Event_Fifo = CANFD_Enable_Transmit_Event_Fifo_LIB(My_fifo_size, Timestamp, CANFD_datatable) 
ENDFUNCTION
'***************************************************************************
''' Modifies the datatable by adding a transmit FIFO. This command makes no
'''+access to the CAN-Controller. The CAN-Controller is accessed by 
'''+CANFD_Init_Controller.
'''+ return value : -1 : RAM full ; Fifo is not set
'''+                0  : OK
''' Fifo_no : number of the fifo from which the object should be read
''' PLZ : pay load Size 0 =  8 data byte
'''+                    1 = 12 data byte
'''+                    2 = 16 data byte
'''+                    3 = 20 data byte
'''+                    4 = 24 data byte
'''+                    5 = 32 data byte
'''+                    6 = 48 data byte
'''+                    7 = 64 data byte
''' Fifo_size : depth of the fifo
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
FUNCTION CANFD_Enable_Transmit_Fifo(Fifo_no, PLS, Fifo_size, CANFD_datatable[]) AS LONG
  DIM My_fifo_size AS LONG
  My_fifo_size = fifo_size - 1
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_Enable_Transmit_Fifo = CANFD_Enable_Transmit_Fifo_LIB(Fifo_no, PLS, MY_Fifo_size, CANFD_datatable)
ENDFUNCTION
'***************************************************************************
''' Modifies the datatable by activating and configuring the transmit Queue. 
'''+This command makes no access to the CAN-Controller. The CAN-Controller 
'''+is accessed by CANFD_Init_Controller.
'''+ return value : -1 : RAM full ; Fifo is not set
'''+                0  : OK
''' PLZ : pay load Size 0 =  8 data byte
'''+                    1 = 12 data byte
'''+                    2 = 16 data byte
'''+                    3 = 20 data byte
'''+                    4 = 24 data byte
'''+                    5 = 32 data byte
'''+                    6 = 48 data byte
'''+                    7 = 64 data byte
''' Fifo_size : depth of the fifo
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
FUNCTION CANFD_Enable_Transmit_Queue(PLS, Fifo_size, CANFD_datatable[]) AS LONG
  DIM My_fifo_size AS LONG
  My_fifo_size = fifo_size - 1
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_Enable_Transmit_Queue = CANFD_Enable_Transmit_Queue_LIB(PLS, MY_Fifo_size, CANFD_datatable) 
ENDFUNCTION

'***************************************************************************
''' Calculates the values for tseg1, tseg2 and bpr depending on the passed
'''+baudrate. This command makes no access to the CAN-Controller. 
'''+The CAN-Controller is accessed by CANFD_Init_Controller.
'''+ return value : 0 : Baudrate is set
'''+                1 : Baudrate is not allowed
''' baud : baudrate
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
Function CANFD_CALC_Baudrate(baud, CANFD_register) AS LONG  ''<HIDE>    
  CANFD_CALC_Baudrate = CANFD_CALC_Baudrate_LIB(baud, CANFD_register) 
EndFunction
'***************************************************************************
''' Modifies the datatable by setting the nominal baudrate. 
'''+This command makes no access to the CAN-Controller. The CAN-Controller 
'''+is accessed by CANFD_Init_Controller.
'''+The CAN-Controller is accessed by CANFD_Init_Controller.
'''+ return value : 0 : Baudrate is set
'''+                1 : Baudrate is not allowed
''' baud : baudrate
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
FUNCTION CANFD_Set_Baudrate_Nominal(baud, CANFD_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  DIM CANFD_register AS LONG
  CANFD_Set_Baudrate_Nominal = CANFD_CALC_Baudrate(baud, CANFD_register)
  CANFD_datatable[CANFD_IDX_C1NBTCFG] = CANFD_register
ENDFUNCTION
'***************************************************************************
''' Modifies the datatable by setting the data baudrate. 
'''+This command makes no access to the CAN-Controller. The CAN-Controller 
'''+is accessed by CANFD_Init_Controller.
'''+The CAN-Controller is accessed by CANFD_Init_Controller.
'''+ return value : 0 : Baudrate is set
'''+                1 : Baudrate is not allowed
''' baud : baudrate
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
FUNCTION CANFD_Set_Baudrate_Data(baud, CANFD_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  DIM CANFD_register AS LONG
  CANFD_Set_Baudrate_Data = CANFD_CALC_Baudrate(baud, CANFD_register)
  CANFD_datatable[CANFD_IDX_C1DBTCFG] = CANFD_register
ENDFUNCTION
'***************************************************************************
''' Modifies the datatable by setting the Transmitter delay compensation. 
'''+This command makes no access to the CAN-Controller. The CAN-Controller 
'''+is accessed by CANFD_Init_Controller.
'''+The CAN-Controller is accessed by CANFD_Init_Controller.
''' TDCMOD : TDC Mode 0 = disabled; 1 = manual; 2 = auto
''' TDCO : TDC Offset -64..63
''' TDCV : TDC value 0..63
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
SUB CANFD_Set_TDC(TDCMOD, TDCO, TDCV, CANFD_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  DIM CANFD_register AS LONG
  CANFD_register = CANFD_datatable[CANFD_IDX_C1TDC] AND 0FF000000H
  CANFD_register = CANFD_register OR SHIFT_LEFT(TDCMOD, 16)
  CANFD_register = CANFD_register OR SHIFT_LEFT(TDCO, 08)
  CANFD_register = CANFD_register OR TDCV
  CANFD_datatable[CANFD_IDX_C1TDC] = CANFD_register
ENDSUB

'***************************************************************************
'''This command makes no access to the CAN-Controller. The CAN-Controller 
'''+The CAN-Controller is accessed by P2_CANFD_Init_Controller.
'''+Globally sets the CAN FD basic message length to 11 bit or 12 bit for the CAN-Controller.
'''EN_SID11: 0 = disable; 1 = enable
'''canfd_datatable: Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
SUB CANFD_Set_SID11(EN_SID11, canfd_datatable[]) AS LONG
  System_Array_Debug_Check(canfd_datatable, 1, 512)
  DIM CANFD_register AS LONG
  CANFD_register = canfd_datatable[CANFD_IDX_C1TDC] AND 000FFFFFFH
  CANFD_register = CANFD_register OR SHIFT_LEFT(EN_SID11, 24)
  canfd_datatable[CANFD_IDX_C1TDC] = CANFD_register
ENDSUB
'***************************************************************************
''' Reads the register TREC form the CAN controller and writes the value to
'''+the CANFD_datatable. 
'''+ return value : value of register TREC
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_TREC(CANFD_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_datatable[CANFD_TREC] = CANFD_Get_Reg(CANFD_datatable[CANFD_IDX_Channel], CANFD_ADR_C1TREC)
  CANFD_GET_TREC = CANFD_datatable[CANFD_TREC]
ENDFUNCTION
'***************************************************************************
''' Extracts TXBO: Transmitter in Bus Off State (Register TREC)
'''+The command CANFD_GET_TREC must be executed before.
'''+ return value : TXBO
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_TXBO(CANFD_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_TXBO = SHIFT_RIGHT(CANFD_datatable[CANFD_TREC], 20) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts TXBP: Transmitter in Error Passive State (Register TREC)
'''+The command CANFD_GET_TREC must be executed before.
'''+ return value : TXBP
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_TXBP(CANFD_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_TXBP = SHIFT_RIGHT(CANFD_datatable[CANFD_TREC], 19) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts RXBP: Receiver in Error Passive State (Register TREC)
'''+The command CANFD_GET_TREC must be executed before.
'''+ return value : RXBP
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_RXBP(CANFD_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_RXBP = SHIFT_RIGHT(CANFD_datatable[CANFD_TREC], 18) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts TXWARN: Transmitter in Error Warning State (Register TREC)
'''+The command CANFD_GET_TREC must be executed before.
'''+ return value : TXWARN
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_TXWARN(CANFD_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_TXWARN = SHIFT_RIGHT(CANFD_datatable[CANFD_TREC], 17) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts RXWARN: Receiver in Error Warning State (Register TREC)
'''+The command CANFD_GET_TREC must be executed before.
'''+ return value : RXWARN
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_RXWARN(CANFD_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_RXWARN = SHIFT_RIGHT(CANFD_datatable[CANFD_TREC], 16) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts EWARN: Transmitter or Receiver in Error Warning State (Register TREC)
'''+The command CANFD_GET_TREC must be executed before.
'''+ return value : EWARN
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_EWARN(CANFD_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_EWARN = SHIFT_RIGHT(CANFD_datatable[CANFD_TREC], 15) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts TEC: Transmitter Error Count (Register TREC)
'''+The command CANFD_GET_TREC must be executed before.
'''+ return value : TEC
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_TEC(CANFD_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_TEC = SHIFT_RIGHT(CANFD_datatable[CANFD_TREC], 8) AND 0FFH
ENDFUNCTION
'***************************************************************************
''' Extracts REC: Receiver Error Count (Register TREC)
'''+The command CANFD_GET_TREC must be executed before.
'''+ return value : REC
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_REC(CANFD_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_REC = CANFD_datatable[CANFD_TREC] AND 0FFH
ENDFUNCTION
'***************************************************************************
''' Reads a event message object form the CAN controller
'''+ return value : -1 : No new message
'''+               >-1 : ID
''' CAN_MSG : array to which the object should be written; the lenght must be at least 3 elements
'''+         CAN_MSG[1] = Header 
'''+         CAN_MSG[2] = Header
'''+         CAN_MSG[3] = Transmit message timestamp
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
FUNCTION CANFD_Read_EFO(CANFD_datatable[], MSG[]) AS LONG
  System_Array_Debug_Check(MSG, 1, 3)
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_Read_EFO = CANFD_Read_EFO_LIB(CANFD_datatable, MSG)
ENDFUNCTION
'***************************************************************************
''' Enables the transmit of messages which are stroed before in a transmit fifo
''' channel : number of the CAN interface on the CAN module
''' Fifo_no : Number of the transmit fifo
'''****************************************************************************
SUB CANFD_Transmit_MSG(channel, Fifo_no)
  CANFD_Set_Reg(channel, CANFD_ADR_C1TXREQ, SHIFT_LEFT(01H, Fifo_no))
ENDSUB
'***************************************************************************
''' Enables the transmit of messages which are stroed before in transmit fifos
''' channel : number of the CAN interface on the CAN module
''' Fifo_pattern : Pattern of the fifos which objects should be send
'''****************************************************************************
SUB CANFD_Transmit_Multi_MSG(channel, Fifo_pattern)
  CANFD_Set_Reg(channel, CANFD_ADR_C1TXREQ, SHIFT_LEFT(Fifo_pattern, 01H))
ENDSUB
'***************************************************************************
''' Reads the register BDIAG0 form the CAN controller and writes the value to
'''+the CANFD_datatable. 
'''+ return value : value of register BDIAG0
''' module : number of CAN module
''' channel : number of the CAN interface on the CAN module
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_BDIAG0(CANFD_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_datatable[CANFD_BDIAG0] = CANFD_Get_Reg(CANFD_datatable[CANFD_IDX_Channel], CANFD_ADR_C1BDIAG0)
  CANFD_GET_BDIAG0 = CANFD_datatable[CANFD_BDIAG0]
ENDFUNCTION
'***************************************************************************
''' Reads the register BDIAG1 form the CAN controller and writes the value to
'''+the CANFD_datatable. 
'''+ return value : value of register BDIAG1
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_BDIAG1(CANFD_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_datatable[CANFD_BDIAG1] = CANFD_Get_Reg(CANFD_datatable[CANFD_IDX_Channel], CANFD_ADR_C1BDIAG1)
  CANFD_GET_BDIAG1 = CANFD_datatable[CANFD_BDIAG1]
ENDFUNCTION
'***************************************************************************
''' Extracts DTERRCNT: Data Bit Rate Transmit Error Count (Register BDIAG0)
'''+The command CANFD_GET_BDIAG0 must be executed before.
'''+ return value : DTERRCNT
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_DTERRCNT(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_DTERRCNT = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG0], 24) AND 0FFH
ENDFUNCTION
'***************************************************************************
''' Extracts DRERRCNT: Data Bit Rate Receive Error Count (Register BDIAG0)
'''+The command CANFD_GET_BDIAG0 must be executed before.
'''+ return value : DRERRCNT
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_DRERRCNT(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_DRERRCNT = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG0], 16) AND 0FFH
ENDFUNCTION
'***************************************************************************
''' Extracts NTERRCNT: Nominal Bit Rate Transmit Error Count (Register BDIAG0)
'''+The command CANFD_GET_BDIAG0 must be executed before.
'''+ return value : NTERRCNT
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_NTERRCNT(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_NTERRCNT = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG0], 8) AND 0FFH
ENDFUNCTION
'***************************************************************************
''' Extracts NRERRCNT: Nominal Bit Rate Receive Error Count (Register BDIAG0)
'''+The command CANFD_GET_BDIAG0 must be executed before.
'''+ return value : NRERRCNT
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_NRERRCNT(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_NRERRCNT = CANFD_datatable[CANFD_BDIAG0] AND 0FFH
ENDFUNCTION
'***************************************************************************
''' Extracts EFMSGCNT: Error Free Message Count (Register BDIAG1)
'''+The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : EFMSGCNT
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_EFMSGCNT(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_EFMSGCNT = CANFD_datatable[CANFD_BDIAG1] AND 0FFFFH
ENDFUNCTION
'***************************************************************************
''' Extracts DLCMM: DLC mismatch (Register BDIAG1)
'''+The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : DLCMM
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_DLCMM(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_DLCMM = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 31) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts ESI: ESI Flag was set (Register BDIAG1)
'''+The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : ESI
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_ESI(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_ESI = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 30) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts DCRCERR: Data rate CRC Error (Register BDIAG1)
'''+The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : DCRCERR
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_DCRCERR(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_DCRCERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 29) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts DSTUFERR: Data rate Stuff bit Error (Register BDIAG1)
'''+The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : DSTUFERR
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_DSTUFERR(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_DSTUFERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 28) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts DFORMERR: Data rate fixed format Error (Register BDIAG1)
'''+The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : DFORMERR
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_DFORMERR(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_DFORMERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 27) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts DBIT1ERR: Data rate recessive bit was monitored dominant Error (Register BDIAG1)
'''*The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : DBIT1ERR
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_DBIT1ERR(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_DBIT1ERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 25) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts DBIT0ERR: Data rate recessive bit was monitored dominant Error (Register BDIAG1)
'''+The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : DBIT0ERR
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_DBIT0ERR(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_DBIT0ERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 24) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts TXBOERR: Bus Off Error (Register BDIAG1)
'''+The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : TXBOERR
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_TXBOERR(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_TXBOERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 23) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts NCRCERR: Nominal rate CRC Error (Register BDIAG1)
'''+The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : NCRCERR
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_NCRCERR(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_NCRCERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 21) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts NSTUFERR: Nominal rate Stuff bit Error (Register BDIAG1)
'''+The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : NSTUFERR
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_NSTUFERR(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_NSTUFERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 20) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts NFORMERR: Nominal rate fixed format Error (Register BDIAG1)
'''+The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : NFORMERR
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_NFORMERR(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_NFORMERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 19) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts NACKERR: Nominal Transmit message was not acknowledged (Register BDIAG1)
'''+The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : NACKERR
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_NACKERR(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_NACKERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 18) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts NBIT1ERR: Nominal rate recessive bit was monitored dominant Error (Register BDIAG1)
'''+The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : NBIT1ERR
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_NBIT1ERR(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_NBIT1ERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 17) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts NBIT0ERR: Nominal rate recessive bit was monitored dominant Error (Register BDIAG1)
'''+The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : NBIT0ERR
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_NBIT0ERR(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_NBIT0ERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 16) AND 01H
ENDFUNCTION
'***************************************************************************
''' Extracts EFMSGCNT: Error free MSG count (Register BDIAG1)
'''+The command CANFD_GET_BDIAG1 must be executed before.
'''+ return value : EFMSGCNT
''' CANFD_datatable : Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION CANFD_GET_EFMSGCNT(CANFD_datatable[]) AS LONG''<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_GET_EFMSGCNT = CANFD_datatable[CANFD_BDIAG1] AND 0FFFFH
ENDFUNCTION



'<ENDREGION>














