#ifndef __UDPADwin_h__
#define __UDPADwin_h__

#include <stdint.h>
#ifdef WIN32
    typedef int socklen_t;
#endif

struct  typ_UDPH1_alt {
    uint32_t befehl;
    int32_t paket_index;
    char password[10];
    unsigned char dummy_fill[2];
    int32_t value[4];
    int32_t link;
    int32_t timeout;
    int32_t dummy1;
    int32_t dummy2;
};
typedef struct typ_UDPH1_alt UDPH1_alt;

struct  typ_UDPH1 {
    uint32_t befehl;
    int32_t paket_index;
    char password[10];
    unsigned char dummy_fill[2];
    int32_t value[4];
    int32_t link;
    int32_t timeout;
    int32_t dummy1;
    int32_t dummy2;
    int32_t DLLVersion;
};
typedef struct typ_UDPH1 UDPH1;

struct  typ_UDPH2 {
    int32_t paket_index;
    int32_t PacketNr;
    int32_t p_size;
    int32_t value[100];
};
typedef struct typ_UDPH2 UDPH2;

struct  typ_UDPR1 {
    int32_t status;
    int32_t paket_index;
    int32_t value[4];
    int32_t dummy1;
    int32_t dummy2;
};
typedef struct typ_UDPR1 UDPR1;

struct  typ_UDPR2 {
    int32_t status;
    int32_t paket_index;
    int32_t value[250];
};
typedef struct typ_UDPR2 UDPR2;

struct  typ_UDPR3 {
    int32_t paket_index;
    int32_t PacketNr;
    int32_t value[350];
};
typedef struct typ_UDPR3 UDPR3;

struct  typ_UDPR4 {
    int32_t status;
    int32_t paket_index;
    int32_t value[350];
    int32_t PacketNr;
    int32_t datatyp;
};
typedef struct typ_UDPR4 UDPR4;

struct typ_GetDataStatus {
    uint32_t packetIndex;
    uint16_t packetNumber[8];
    unsigned char status[8];
    uint32_t dummy[10];
};
typedef struct typ_GetDataStatus GetDataStatus;

struct typ_UDPIn {
    uint32_t befehl;
    uint32_t StructVersion;
    uint32_t Mac1, Mac2;
    uint32_t IP1, IP2;
    uint32_t SubNet1, SubNet2;
    uint32_t Gateway1, Gateway2;
    uint32_t useDhcp;
    uint32_t ADwinPort;
    char Passwort[10];
    unsigned char Bootloader;   // V2.51
    unsigned char cdummy[3];    // V2.51
    uint32_t Bezeichnung[4];    // V2.52
    uint32_t Dummy[5];      // V2.52
};
typedef struct typ_UDPIn UDPIn;

struct typ_UDPStatus {
    uint32_t Pattern;
    uint32_t StructVersion;
    uint32_t Status;
    uint32_t Version_Server;
    uint32_t Version_XILINX;
    unsigned char MAC[8];
    uint16_t Port;
    uint8_t DHCP;
    uint8_t Netmask;
    uint32_t Gateway;
    uint8_t unused[11];
    uint8_t Reply_With_Broadcast;
    uint32_t ScanID;
};
typedef struct typ_UDPStatus UDPStatus;

struct typ_UDPEXTStatus {
    unsigned char MAC[8];
    uint32_t Pattern;
    uint32_t StructVersion;
    uint32_t Bezeichnung[4];
    uint32_t timer_resets;
    uint32_t socket_downs;
    uint32_t disk_free;
    uint32_t disk_size;
    char date[8];
    char revision[8];
    uint16_t processor_type;
    uint16_t system_type;
    uint32_t Frei[91];
};
typedef struct typ_UDPEXTStatus UDPEXTStatus;

struct  typ_UDPOut {
    int32_t status;
    char mac[6];
    uint32_t net_mask;
    uint32_t gateway;
    int16_t dhcp;
    uint16_t port;
};
typedef struct typ_UDPOut UDPOut;

struct typ_IXP425_Flash_Update {
    uint32_t Pattern;
    uint32_t StructVersion;
    uint32_t ID;
    uint32_t Status;
    uint32_t Timeout;
    char Dateiname[24];
    unsigned char MAC[8];
    uint32_t Dummy[10];
};
typedef struct typ_IXP425_Flash_Update UDPUpdate;

struct typ_InitAck {
    uint32_t pattern;
    uint32_t reboot;
    unsigned char mac[8];
    uint32_t dummy[20];
};
typedef struct typ_InitAck UDPInitAck;

// getDataStatus
#define k_gds_ok                      0
#define k_gds_nok                     1

/*
 * Processor constants
 * (These differ from those <linux/adwin.h> defines ...
 * the k_proc defines are the values that are returned to the user
 * the k_proc_net values are the values received/send on the net
 */
#define k_proc_t2               2
#define k_proc_t4               4
#define k_proc_t5               5
#define k_proc_t8               8
#define k_proc_t9               9
#define k_proc_t10           1010
#define k_proc_t11           1011

#define k_proc_net_t9        1000
#define k_proc_net_t10       1010
#define k_proc_net_t11       1011

// Errorcodes
#define k_ok                          0

#define k_timeout_to_link             1
#define k_timeout_from_link           2
#define k_timeout_fast_to_link        3
#define k_timeout_fast_from_link      4
#define k_this_link_not_allowed      10
#define k_wrong_version              20

#define k_timeout                     5
#define k_UDPtimeout                 -1
#define k_WrongPassword              -5
#define k_TryLater                  -10
#define k_DateiFehler               -15
#define k_PaketFehler               -20
#define k_Paketzugross              -25
#define k_WrongSize                 -26
#define k_WrongVersion              -30 // should it be -20?
#define k_DataZuKlein               -31
#define k_FifoLessData              -32
#define k_FalschePaketreihenfolge   -33
#define k_WrongBinfile              -35
#define k_SchonBearbeitet           -40
#define k_RetryUnknown              -41
#define k_MemError         -100 // 20.01.05: Fehler aus Speicherverwaltung T11


// Befehle

//*******************************************************************
#define k_3plus1                      0
// Bei diesen Befehlen value[0] -> value[2]
// direkt an Link
#define k_GetPar                      1
#define k_Start                       2
#define k_Stop                        3
#define k_lMemory                     5
#define k_SetPar                      6
#define k_Clear_Data                  9
#define k_GetDataLength              11
#define k_MemoryAll                  12
#define k_ClearProcess               14
#define k_ADC                        15
#define k_DAC                        16
#define k_GetDigin                   17
#define k_SetDigout                  18
#define k_GetDigout                  19
#define k_Auslastung                 20
#define k_ClearFifo                  21
#define k_GetFifoEmpty               22
#define k_GetFifoCount               23
//_______________________________________________________________
#define k_LadeBin                     4
#define k_GetDataStringSize          44
#define k_GetDataInfo                45
#define k_GetDataType               100
#define k_GetData                     7
#define k_GetDataShiftedHandshake   107
#define k_GetDatasmall              207
#define k_SetData                     8
#define k_SetDataLastStatus         108
#define k_CreateData                 10
#define k_GetParAll                  13
#define k_GetFifo                    24
#define k_GetFifoRetry              124
#define k_SetFifo                    25
#define k_SetFifoRetry              125
#define k_Boot                       50
#define k_ARMVersion               1000
#define k_TestVersion               255
#define k_Authenticate          300
#define k_GetMemoryDSP          1000000
//*****************************************************************

// Spelling errors, duplicates...
#define k_armVersion k_ARMVersion
#define k_ZuWenigDatenImFifo k_FifoLessData
#define k_GetDataSH k_GetDataShiftedHandshake

#define k_max_retry_get               5
#define k_max_retry                   5
#define k_max_retry_udp               5

//FehlerCodes
#define k_Data_is_to_small          100
#define k_Fifo_is_to_small          101
#define k_Fifo_to_less_data         102
#define k_Mem_Error                 150
#define k_File_not_found            200
#define k_File_not_binaer           202
#define k_File_not_valid            203
#define k_File_not_btl              204
#define k_WrongBinFile              205

#define k_error_tcp_error          2000
#define k_error_tcp_timout_read    2001
#define k_error_tcp_password       2002

#define OS_WINDOWS 0
#define OS_LINUX 0x10
#define OS_JAVA 0x20
#define OS_DOT_NET 0x40
#define OS_GENERIC 0x80

#endif //__UDPADwin_h__
