//Example (needs a T9 on Device 0x105):

function Check_Errors()
	tmp_err = Get_Last_Error()
	if (tmp_err <> 0) then
		foo=Get_Last_Error_Text(tmp_err)
		printf("%s", foo)
		pause
	end
endfunction

function My_Abort()
	printf("Test failed.\n")
	pause
endfunction

//////////////////////////////////////////////////////////////////////
// Test process handling/memory management
//////////////////////////////////////////////////////////////////////
Set_DeviceNo(hex2dec("105"))
Check_Errors()
Boot("ADwin9.btl")
Check_Errors()
a = Test_Version()
Check_Errors()
if (a <> 0) then
	My_Abort()
end
Load_Process("scilab-test.t91")
Check_Errors()
Start_Process(1)
Check_Errors()
TmpMem=Free_Mem(1)
Check_Errors()
Stop_Process(1)
Check_Errors()
// wait for Process to terminate
while (Process_Status(1) <> 0) do
	Check_Errors() 
end
Check_Errors()
Clear_Process(1)
Check_Errors()
// check if memory was freed 
if (Free_Mem(1) <= TmpMem) then
	My_Abort()
end
Check_Errors()

//////////////////////////////////////////////////////////////////////
// Prepare for the following tests: 
//////////////////////////////////////////////////////////////////////
Set_DeviceNo(hex2dec("105"))
Check_Errors()
Boot("ADwin9.btl")
Check_Errors()
a = Test_Version()
Check_Errors()
if (a <> 0) then
	My_Abort()
end
// now reload and restart process
Load_Process("scilab-test.t91")
Check_Errors()
Start_Process(1)
Check_Errors()
// wait for process to become ready
while (Get_Par(1) == 0) do 
	Check_Errors()
end
Check_Errors()


//////////////////////////////////////////////////////////////////////
// check Data_Length (Long+Float)
//////////////////////////////////////////////////////////////////////
a = Data_Length(1)
Check_Errors()
if (a <> 1000) then
	My_Abort()
end

a = Data_Length(4)
Check_Errors()
if (a <> 2000) then
	My_Abort()
end

//////////////////////////////////////////////////////////////////////
// check Data2File - this is difficult to check automatically
//////////////////////////////////////////////////////////////////////
Data2File("test.dat", 1, 1, 100, 1)
Check_Errors()

//////////////////////////////////////////////////////////////////////
// check Fifo_Empty/Full/Clear (Long+Float)
//////////////////////////////////////////////////////////////////////
a = Fifo_Empty(2)
Check_Errors()
if (a <> 0) then
	My_Abort()
end

a = Fifo_Empty(4)
Check_Errors()
if (a <> 1000) then
	My_Abort()
end

a = Fifo_Full(2)
Check_Errors()
if  (a <> 1000) then
	My_Abort()
end

a = Fifo_Full(4)
Check_Errors()
if  (a <> 1000) then
	My_Abort()
end

Fifo_Clear(2)
Check_Errors()

Fifo_Clear(4)
Check_Errors()

a = Fifo_Full(4)
Check_Errors()
if  (a <> 0) then
	My_Abort()
end

a = Fifo_Empty(4)
Check_Errors()
if  (a <> 2000) then
	My_Abort()
end

//////////////////////////////////////////////////////////////////////
// check Get_Par/Set_Par (Long+Float)
//////////////////////////////////////////////////////////////////////
a = Get_FPar(42)
Check_Errors()
if  (a <> 0) then 
	My_Abort()
end
Set_FPar(42, 24)
Check_Errors()
a = Get_FPar(42)
Check_Errors()
if  (a <> 24) then 
	My_Abort()
end

a = Get_Par(42)
Check_Errors()
if  (a <> 0) then 
	My_Abort()
end
Set_Par(42, 24)
Check_Errors()
a = Get_Par(42)
Check_Errors()
if  (a <> 24) then 
	My_Abort()
end

//////////////////////////////////////////////////////////////////////
// check Get_Par_All/Get_FPar_All
//////////////////////////////////////////////////////////////////////
a = [0]
a = Get_FPar_All();
Check_Errors()
if  (a(79) <> 0) then 
	My_Abort()
end
if  (a(42) <> 24) then 
	My_Abort()
end

a = [0]
a = Get_Par_All();
Check_Errors()
if  (a(79) <> 0) then 
	My_Abort()
end
if  (a(42) <> 24) then 
	My_Abort()
end

//////////////////////////////////////////////////////////////////////
// check Get_Par_Block/Get_FPar_Block
//////////////////////////////////////////////////////////////////////
a = [0]
a = Get_FPar_Block(40,10)
Check_Errors()
if  (a(9) <> 0) then 
	My_Abort()
end
if  (a(3) <> 24) then 
	My_Abort()
end

a = [0]
a = Get_Par_Block(40,10)
Check_Errors()
if  (a(9) <> 0) then 
	My_Abort()
end
if  (a(3) <> 24) then 
	My_Abort()
end

//////////////////////////////////////////////////////////////////////
// check Get_Processdelay/Set_Processdelay/Workload
//////////////////////////////////////////////////////////////////////
a = Workload(1)
Check_Errors()
a = Workload(1)
Check_Errors()
if  ((a > 10) | (a < 2)) then 
	My_Abort()
end
a = Get_Processdelay(1)
Check_Errors()
if  (a <> 1000) then 
	My_Abort()
end
Set_Processdelay(1, 100)
Check_Errors()
a = Workload(1)
Check_Errors()
a = Workload(1)
Check_Errors()
if  ((a < 10) | (a > 30)) then 
	My_Abort()
end

//////////////////////////////////////////////////////////////////////
// check Processor_Type
//////////////////////////////////////////////////////////////////////
a = Processor_Type()
Check_Errors()
if  (a <> 9) then 
	My_Abort()
end

//////////////////////////////////////////////////////////////////////
// check SetFifo/GetFifo (Long+Float)
//////////////////////////////////////////////////////////////////////
d=[501,502,503,504]
SetFifo_Long(2,d)
Check_Errors()
a = Fifo_Full(2)
Check_Errors()
if  (a <> 4) then
	My_Abort()
end
c(1) = 42
c=GetFifo_Long(2,4)
Check_Errors()
if  ( c(1) <> d(1) ) then // todo
	My_Abort()
end

SetFifo_Float(4,d)
Check_Errors()
a = Fifo_Full(4)
Check_Errors()
if  (a <> 4) then
	My_Abort()
end
c(1) = 42
c=GetFifo_Float(4,4)
Check_Errors()
if  (c(1) <> d(1)) then // todo
	My_Abort()
end

//////////////////////////////////////////////////////////////////////
// check SetData/GetData (Long+Float+String)
//////////////////////////////////////////////////////////////////////

SetData_Long(1,d,1)
Check_Errors()
c(1) = 42
c=GetData_Long(1,1,20)
Check_Errors()
if  (c(1) <> d(1)) then // todo
	My_Abort()
end

SetData_Float(3,d,1)
Check_Errors()
c(1) = 42
c=GetData_Float(3,1,20)
Check_Errors()
if  (c(1) <> d(1)) then // todo
	My_Abort()
end

a = String_Length(5)
Check_Errors()
if (a <> 11) then
	My_Abort()
end
s=GetData_String(5,200)
Check_Errors()
// check the notes on GetData_String in the driver for the meaning of 
// the spaces...
if (s <> "        Hello World") then
	My_Abort()
end
SetData_String(5, "FooBar")
Check_Errors()
s=GetData_String(5,200)
Check_Errors()
// check the notes on GetData_String in the driver for the meaning of 
// the spaces...
if (s <> "        FooBar") then
	My_Abort()
end

//////////////////////////////////////////////////////////////////////
// If we reach this line, all tests have passed.
//////////////////////////////////////////////////////////////////////

printf("All tests passed.");
